<?php
define ( 'RATING_ROOT_DIR', dirname ( __FILE__ ) );

$refresh_time = 86400 * 7; // 86400 время в секундах через которое будет происходить обновление.
$site_name = "torrentpier"; //Сюда вписываем название вашего сайта.
$filmurl = htmlspecialchars(trim($_REQUEST['url']));
$filmurl_array = parse_url($filmurl);
$film_id = str_replace("/title/","", $filmurl_array['path']);
$film_id = str_replace("/","", $film_id);
$filmurl = "http://www.imdb.com/title/". $film_id ."/";
if($filmurl_array['host'] == "www.imdb.com")
{
	if(!file_exists( RATING_ROOT_DIR . "/imdb/". $film_id .".png" ) OR (time() - filemtime( RATING_ROOT_DIR . "/imdb/". $film_id .".png")) > $refresh_time )
	{
		$film = file_get_contents($filmurl);
		preg_match_all('#<span itemprop="ratingValue">(.*?)</span>.*?<span itemprop="ratingCount">(.*?)</span>#isu', $film, $imdb, PREG_SET_ORDER);
		$imdb_rating = $imdb[0][1];
		$imdb_votes = $imdb[0][2];
		if($imdb_rating != 0)
		{
			$image = imagecreatefrompng( RATING_ROOT_DIR . "/source/back_imdb.png");
			$star = imagecreatefrompng( RATING_ROOT_DIR . "/source/star.png");
			$font =  RATING_ROOT_DIR . "/source/Intermosaic.ttf";
			$color = imagecolorallocate($image, 190, 190, 190);			
			$rating_font = imagecreatefrompng( RATING_ROOT_DIR . "/source/rating_font.png");		
			$vote_font = imagecreatefrompng( RATING_ROOT_DIR . "/source/votes_font.png");		
			
			$rating = explode(".", $imdb_rating);		
			
			switch(end($rating))
			{
				case "0": $symbol = 0; break;				
				case "1": $symbol = 10;	$plus = 5; break;				
				case "2": $symbol = 20; break;				
				case "3": $symbol = 30; break;				
				case "4": $symbol = 40; break;				
				case "5": $symbol = 50; break;				
				case "6": $symbol = 60; break;		
				case "7": $symbol = 70; break;				
				case "8": $symbol = 80; break;				
				case "9": $symbol = 90; break;
			}			
			switch(reset($rating))
			{
				case "0": $symbol2 = 0;	break;				
				case "1": $symbol2 = 10;/* $plus2 = 5;*/ break;				
				case "2": $symbol2 = 20; break;				
				case "3": $symbol2 = 30; break;				
				case "4": $symbol2 = 40; break;				
				case "5": $symbol2 = 50; break;				
				case "6": $symbol2 = 60; break;			
				case "7": $symbol2 = 70; break;				
				case "8": $symbol2 = 80; break;				
				case "9": $symbol2 = 90; break;
			}						
			imagecopy($image, $rating_font, 93+$plus, 4, $symbol, 0, 10, 10);
			imagecopy($image, $rating_font, 88+$plus, 4, 100, 0, 10, 10);
			imagecopy($image, $rating_font, 76+$plus+$plus2, 4, $symbol2, 0, 10, 10);						
			$symbol_count = strlen($imdb_votes);		
			for ($i = 0, $next = 105 - $symbol_count*5; $i != $symbol_count; $i++, $next = $next + 5) {			
				$symbol = substr($imdb_votes, $i, 1);
				if($symbol == ",") $symbol = 40; else $symbol = intval($symbol)*4;
				imagecopy($image, $vote_font, $next, 18, $symbol, 0, 4, 6);			
			}			
			imagettftext($image, 6, 0, 30, 45, $color, $font, $site_name);			
			for ($i = 0, $next = 0; $i != (int)$imdb_rating; $i++, $next = $next + 12) {
				imagecopy($image, $star, $next, 27, 0, 0, 10, 10);
			}
			$half_rating = end(explode(".", $imdb_rating));
			imagecopy($image, $star, $next, 27, 0, 0, $half_rating, 11);
			imagepng($image, RATING_ROOT_DIR . "/imdb/". $film_id .".png",9);
		} else {
			$image = imagecreatefrompng( RATING_ROOT_DIR . "/source/na_imdb.png");
		}
	} else {
		$image = imagecreatefrompng( RATING_ROOT_DIR . "/imdb/". $film_id .".png");			
	}	
# Display the image
header("Content-type: image/png");
imagepng($image);		
} else {
	$image = imagecreatefrompng( RATING_ROOT_DIR . "/source/na_imdb.png");
	header("Content-type: image/png");
	imagepng($image);
}
imagedestroy ($image);
?>
